#!/usr/bin/env python3

import sys

import blup.animation
import blup.writebml

anim = blup.animation.load(sys.argv[1])
plasmaanim = blup.animation.load('/tmp/plasma.bml')
newanim = blup.animation.Animation(anim.dimension)

plasmaFrame = 0
for f in anim:
	newframe = blup.animation.AnimationFrame(f.dimension, f.delay)
	for x in range(anim.dimension.width):
		for y in range(anim.dimension.height):
			p = f.getPixel(x,y)
			if max(p) > 14:
				newframe.setPixel(x,y, plasmaanim[plasmaFrame].getPixel(x,y))
	newanim.addFrame(newframe)
	plasmaFrame += 1

blup.writebml.writeBml(newanim, '/tmp/colormarq.bml')

